host info updates
[distro-setup] / mail-backup-clean
index 993839f78180df5c1ea2421fcf64faaf1654f5a7..210173cc96d621163955d9411f9099ef6c435087 100755 (executable)
@@ -1,26 +1,45 @@
 #!/bin/bash
-# Copyright (C) 2016 Ian Kelling
-#
+# I, Ian Kelling, follow the GNU license recommendations at
+# https://www.gnu.org/licenses/license-recommendations.en.html. They
+# recommend that small programs, < 300 lines, be licensed under the
+# Apache License 2.0. This file contains or is part of one or more small
+# programs. If a small program grows beyond 300 lines, I plan to switch
+# its license to GPL.
+
+# Copyright 2024 Ian Kelling
+
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
 # You may obtain a copy of the License at
-#
+
 #     http://www.apache.org/licenses/LICENSE-2.0
-#
+
 # Unless required by applicable law or agreed to in writing, software
 # distributed under the License is distributed on an "AS IS" BASIS,
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
+
 if ! test "$BASH_VERSION"; then echo "error: shell is not bash" >&2; exit 1; fi
 shopt -s inherit_errexit 2>/dev/null ||: # ignore fail in bash < 4.4
 set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" exit status: $?, PIPESTATUS: ${PIPESTATUS[*]}" >&2' ERR
 
-cd /mnt/o/btrbk
-tmp=(o*)
-last_snap_date=${tmp[-1]#o.}
-time=$(( $(date -d $(sed -r  's/(.{4})(..)(.{5})(..)(.*)/\1-\2-\3:\4:\5/' <<<$last_snap_date) +%s) -1 ))
-# 1 second granularity, so we could have a duplicate file, oh well, not worrying about that.
-find /bu/md -type f \! -newermt @$time -delete
+## This would delete backups that we already have in snapshots,
+## 1 second granularity, so we could have some duplicates. However,
+## this doesn't account for files received then accidentally deleted,
+## all in between two snapshots, so they aren't in any snapshot.
+## So, instead, just keep a bunch of backups based on time.
+
+# cd /mnt/o/btrbk
+# tmp=(o*)
+# last_snap_date=${tmp[-1]#o.}
+# time=$(( $(date -d $(sed -r  's/(.{4})(..)(.{5})(..)(.*)/\1-\2-\3:\4:\5/' <<<$last_snap_date) +%s) -1 ))
+# find /bu/md -type f \! -newermt @$time -delete
+
+if [[ ! -d /bu/md ]]; then
+  exit 0
+fi
+
+find /bu/md -type f -mtime +100 -delete